 
/**
 * @fileOverview The file for detail-call handling. Details are displayd differently based on settings for particular UI block.
 * The file consists from Detail model and Detailset of all currently created detail-windows.
 * @author 
 * @version 
 */

/**
 * 
 * @constructor
 */

function Detail(detailwidget, name, url) {
	this.detailwidget = detailwidget;
	
	this.did = '';
	this.content_parent = undefined;
	this.content_wrapper = '';
	
	this.url = url;
	this.type = undefined;
	this.name = name;
	this.content = undefined;
	this.temp_id = "";
	this.query = undefined;
	
	this.setData();
	 
};
Detail.prototype.update = function(detailwidget, url){
	this.detailwidget = detailwidget;
	this.temp_id = "";
	this.query = undefined;
	this.url = url;
	this.setData();
	
};
Detail.prototype.setData = function(){
	
	var widget = this.detailwidget;
	
	this.type = blocks_settings[this.name].detail.type;
	switch (this.name){
	case 'query':
		//TODO class standard rename
		this.content = $(widget).closest('.query_wrapper').find('.columns-wrapper');
		this.url  = undefined;
		this.temp_id  = $(widget).closest('.query_wrapper').attr('id');
		this.query = $(widget).closest('.query_wrapper').data('query');
		break;
	case 'collections':
		this.content = $('#collections-block');
		this.url  = undefined;
		break;
	case 'record':
		this.content = undefined;
		if (widget != undefined){
			this.url = $(widget).parent().find("a").attr('href');
		}
		break;
	case 'values':
		this.content = undefined;
		var index = $(widget).closest('.sc-wrapper').find('.index-input').val();
		if (index != ""){
			this.url = "values/htmllist/?q=" + index + "&sort=size&repository=" + getSelectedRepository();//$(widget).parent().find("a").attr('href');
		} 
		break;
	case 'index':
		this.content = undefined;
		this.url = 'terms/htmldetail/?q=all';
		break;
	case 'info':
		this.content = undefined;
		if (this.detailwidget == undefined){
			if (this.url == undefined) {
				this.url = '/MDService2/docs/xml/welcome #welcome';
			}
			if (this.url == null) {
				this.url = '/MDService2/docs/xml/welcome #welcome';
			}

		} else {
			//var a = $(this).parent().next().attr('id');
			this.url = window.location.pathname + "static/info.xml";
		}
		break;
	default:
	}
};
Detail.prototype.getTitle = function(){
	var title = "";
	title = "DETAIL: " + this.name;
	return title;
};
Detail.prototype.create = function(){
	var cw = "<div id='" + this.did  + "' class='detail-wrapper ui-widget' >" + 
	"<div class='detail-header ui-widget-header ui-state-default'>" +// ui-corner-top'>" +
	"<span class='cmd cmd_get'></span>" + 
	"<span class='inner-title'>" + this.getTitle() +"</span>" +
	"<span class='cmd cmd_del'></span></div>" +
	"<div class='detail-content content'></div>" +
	"</div>";
	this.content_wrapper = $(cw);
	$(this.content_wrapper).data('detail', this);
	
};
Detail.prototype.enrichContent = function(){
	if (this.name == 'query'){
		if ($(this.content).find('.columns-selected').children('.widget-wrapper').length == 0){
			var query = this.query;//queryset.getQuery(this.temp_id);
			//enrich link,xml
			//options withSummary
			//var options = "<input type='checkbox' checked='false' id='input-withsummary' name='WS'/><label>with Summary</label>";
			
			var links = "<a class='cmd cmd_xml' target='_blank' href='" + query.link("xml") + "'>sru</a> " +
				"<a class='cmd cmd_link' target='_blank' href='" + query.link("fullpage") + "' >link</a> " +
				"<span class='cmd cmd_withsummary'></span>";
			$(this.content).find('.cmds').append($(links));
			
			
			//enrich with selectionlist
			var selectionlist  = new SelectionList($(this.content).find('.columns-selected'));
			selectionlistset.add(selectionlist);
			//selectionlist.listwidget.query = query;
			selectionlist.load(workspace.getCustomTermsets());//jsonw["WorkspaceProfile"]["CustomTermsets"]);
			$(this.content).find('.cmd_reload').data('selectionlist',selectionlist);
			if (query.columns == ""){
				var autolist = "";
				$('#'+ query.listid).find('.result').find('thead').find('th').each(function(i,item){
					if (i > 0){
						if (i> 1) {
							autolist = autolist + ",";
						}
						autolist = autolist + $(item).text();
					}
				});
				selectionlist.autolist = autolist;
				selectionlist.listwidget.load(autolist.split(','));
				selectionlist.select(1);
			}
			else {
				selectionlist.listwidget.load(query.columns.split(','));
				selectionlist.select(0);
			}
		}
	}
};
Detail.prototype.postprocessSelection = function(){
	if (this.name == "record"){
		queryset.recorddetailselection($(this.detailwidget).parent().parent());
	}
};
Detail.prototype.openContent = function() {
	if (this.content != undefined){
		this.content_parent = $(this.content).parent();
		this.enrichContent();
		$(this.content_wrapper).find('.detail-content').append($(this.content));
		$(this.content).show();
	}
};

Detail.prototype.openUrl = function() {
	if (this.url != undefined){
		$(this.content_wrapper).show();
		$(this.content_wrapper).find('.detail-content').data('id', $(this.detailwidget).parent().next().attr('id'));
		$(this.content_wrapper).find('.detail-content').load(this.url,function(responseText, textStatus, XMLHttpRequest){
			//find info data
			if ($(this).data('id') != null){
				if ($(this).data('id').length > 0){
					$(this).html($(this).find('#' + $(this).data('id') + '-info'));
				}
			}
			var get = $(this).parent().find('.cmd_get');				
			get.removeClass('cmd_get');
			get.addClass('cmd_up');
			handleUIBlock($(this).children('.cmds-ui-block'));
			addPaging($(this).children('.cmds-ui-block'));
			//$(this).show();
			var name = $(this).closest('.detail-wrapper').attr("id");
			if (name == "detail_values"){
				//$(this).find(".cmd_columns").click(function(event) {
				$(this).find(".cmd_query").click(function(event) {
					event.preventDefault();
					handleValueSelection($(this));
				});	
			}
			if (name == "detail_index"){
				$(this).find(".terms-tree").treeTable({initialState:"collapsed"});
				$(this).find("a.value-caller").click(function(event) {
						event.preventDefault();
						handleValueCaller($(this));
					});		
				$(this).find(".terms-tree").find('.treecol').find(".cmd_query").click(function(event) {
						event.preventDefault();
						handleIndexSelection($(this));
				});	
			}
		});
	}
};

Detail.prototype.open = function(){
	
	switch (blocks_settings[this.name].detail.type) {
	case "inline":
		//TODO 
		if (this.content != undefined){
			$(this.content).toggle();
		}
		if (this.url != undefined){
			$(this.detailwidget).after($(this.content_wrapper));
			this.openUrl();
		}
		break;
	case "floating":
		this.openContent();
		showDetail(this.content_wrapper, "html");
		//this.showFloatingDetail();
		this.openUrl();
		break;
	case "pane":
		this.openContent();
		addToDetailList(this.content_wrapper , "detail_" + this.name);
		this.openUrl();
		if (this.url == undefined ) {
			var get = $(this.content_wrapper).find('.cmd_get');				
			get.removeClass('cmd_get');
			get.addClass('cmd_up');
		}
		//$('#detailblock').children('.content').scrollTop($(this.content_wrapper).position().top);
		$('#detailblock').scrollTop($(this.content_wrapper).position().top + $(this.content_wrapper).find('.detail-header').height());
	default://pane ?
	};
		
	this.postprocessSelection();
};
Detail.prototype.close = function(){
	if (this.content_parent != undefined){
		$(this.content).hide();
		this.content_parent.append($(this.content));
	}
};

Detail.prototype.showFloatingDetail = function(){
	var pos = $(this.detailwidget ).offset();
	//var iWidth = (options.width > 0) ? options.width : $input.width();
	// reposition
	$('#detail-floating').css({
		//width: parseInt(iWidth) + "px",
		top: (pos.y + $(this.detailwidget).height()) + "px",
		left: pos.x + "px",
		"z-index": "1000"
	});
	$('#detail-floating').append($(this.content_wrapper));
	$('#detail-floating').show();	
};

/**
 * Reference to UI-element
 * @field
 */ 
var detail_container = $("#detaillist"); 

/**
 * Maintains/Manages the detail-list
 * @constructor
 */
var detailcaller = { details: {},
	container: '#detaillist',
		
	calldetail: function(widget,name, url){
		//var name;
		var detail;
		var content;//, url;
		
		if (name == undefined){
			name = this.getdetailname(widget) ;
			if (name == undefined) {
				alert("detail name -  undefined");
				return;
			}
		}
		// test for values
		if (name == 'values'){
			var index = $(widget).closest('.sc-wrapper').find('.index-input').val();
			if (index == ""){
				return;
			}
		}
		detail = this.details[name];
		//url = this.getdetailurl(name, widget);
		if (detail == undefined) {
			//content = this.getdetailcontent(name, widget);
			detail = new Detail( widget, name, url);
			this.adddetail(detail);
		} else {
			detail.close();
			//content = this.getdetailcontent(name, widget);
			detail.update( widget , url);
		}
		
		detail.open();
	},
	
	
	adddetail: function (detail){		
		this.details[detail.name] = detail;
		detail.did = "detail_" + detail.name;
		detail.create();
	},

	removedetail: function (did) {
		notifyUser("removing detail:"  + did);
		
		var detail = this.getdetail(did);
		//detail.clear();
		this.details[detail.name] = undefined;
		
		$('#' + did).remove();
		
	},
	
	getdetailname: function(widget) {
		var name;
		if ($(widget).parents('.result').length > 0){
			name = "record";
		} else {
			if ($(widget).parents('.result-summary').length > 0) {
				name = "values";
			} else {
				if ($(widget).closest('.ui-widget').attr('name') == 'query'){
					name = 'query';
				} else {
					if  ($(widget).closest('.c-widget').attr('id') == 'collections-widget'){
						name = 'collections';
					} else {
						if ($(widget).attr("name") == "detail_index"){
							name = 'index';
						} else {
							if ($(widget).prev().hasClass("value-input")){
								name = 'values';
							} else {
								if ($(widget).hasClass("cmd_info")){
									name = 'info';
								}
							}
						}
					}
				}
			}
		}
		
		return name;
	},
/*	
	getdetailcontent: function(name, widget) {
		var content;
		switch (name){
		case 'query':
			//TODO class standard rename
			content = $(widget).closest('.query_wrapper').find('.columns-wrapper');
			break;
		case 'record':
			content = undefined;
			break;
		case 'values':
			content = undefined;
			break;
		default:
		}
		return content;
	}, 
	
	getdetailurl: function(name, widget) {
		var url;
		switch (name){
		case 'query':
			url = undefined;
			break;
		case 'record':
			url = $(widget).parent().find("a").attr('href');
			break;
		case 'values':
			url = $(widget).parent().find("a").attr('href');
			break;
		default:
		}

		return url;
	}, 
	*/
	getdetail: function(did) {
		var detail;
		$.each(this.details,function(){
			if (this.did == did) {
				detail = this;
			}
		});
		return detail;
	}
};


function showDetail(_data, textStatus, xmlhttpreq) {	
	try {
		var data = _data;
		var blankdata = "<html><\html>";
		
		if(typeof xmlhttpreq!='undefined')
		{
			if (xmlhttpreq.responseXML != null){
				var isinfo = xmlhttpreq.responseXML.baseURI.split("/static/info.xml?id="); 
				if (isinfo != "undefined"){
					if ( isinfo.length = 2){
						var infoid = new RegExp('[\\?]id=([^&#]*)').exec(xmlhttpreq.responseXML.baseURI);
						infoid = infoid[1] || 0;
						infoid = infoid + "-info";
						data = $(_data).find('#' + infoid);
					}
				}		
			}
		}

		if (!$('#detail-float').is( ":ui-dialog" )) {
			initDetailFloat();
		}
		
		if (data ==  null){
			$('#detail-float').html(blankdata);
			
			openDialog("", true);
		} else
		{		
			// detail data
			var did = $(data).attr("id");
			if (did != undefined){
				if ((did.indexOf("-info") == -1) && (did.length > 0)) {
					var detail = detailcaller.getdetail(did);
					var pos = $(detail.detailwidget).offset();
					pos.top = pos.top + $(detail.detailwidget).height();
					$("#detail-float").dialog('option', 'position', [pos.left,pos.top]);	
				}
			}
			
			$('#detail-float').html(data);
			var title =  $('#detail-float').find('.inner-title').attr('value');
			if (title == undefined) title = $('#detail-float').find('.title, .inner-title').first().text();
			$('#detail-float').dialog( "option", "title", title );
			
			

			$('#detail-float').find('.detail-header').hide();
			$('#detail-float').find('.detail-content').show(); 
			
			openDialog(title,false);
		}
		
	} catch (e) {
			notifyUser(e,'debug');
	}	
}

function openDialog(title, is_get){
	if ( $('#detail-float').dialog("isOpen")) {
		if (! is_get) {
			var get = $('#detail-float').siblings('div.ui-dialog-titlebar').find('.cmd_get');
			get.removeClass('cmd_get').addClass('cmd_up');
			get.removeClass('ui-dialog-titlebar-get').addClass('ui-dialog-titlebar-up');
		} else {
			var up = $('#detail-float').siblings('div.ui-dialog-titlebar').find('.ui-dialog-titlebar-up');
			up.removeClass('.cmd_up .ui-dialog-titlebar-up').addClass('.cmd_get .ui-dialog-titlebar-get');
			var down = $('#detail-float').siblings('div.ui-dialog-titlebar').find('.ui-dialog-titlebar-down');
			down.removeClass('.cmd_down .ui-dialog-titlebar-down').addClass('.cmd_get .ui-dialog-titlebar-get');
		}		
		$('#detail-float').siblings('div.ui-dialog-titlebar').find('.ui-dialog-title').text(title);
		//$('#detail-float').closest('.ui-dialog').show();
		
	} else {
		$('#detail-float').dialog('open');
		$('#detail-float').siblings('div.ui-dialog-titlebar').addClass('ui-state-default');
		$('#detail-float').siblings('div.ui-dialog-titlebar').children().remove();
		var x = '<span class="cmd cmd_del ui-dialog-titlebar-del "/>' ;
		if (is_get){
			x = x + '<span class="cmd cmd_get ui-dialog-titlebar-get"/>';
		} else {
			x = x + '<span class="cmd cmd_up ui-dialog-titlebar-up"/>';
		}
		x = x + '<span class="ui-dialog-title">' + title +'</span>';
		$('#detail-float').siblings('div.ui-dialog-titlebar').append(x);				
	
		
		$("#detail-float").dialog({
			beforeclose: function(event, ui) {
			
			var did;
			if ($(this).length > 0){
				did = $(this).find('.detail-wrapper').attr('id');
			}
			if (did != undefined){
				detail = detailcaller.getdetail(did);
				detail.close();
				//if (detail.name == "collections"){
					detailcaller.removedetail(did);
				//}
			}
		
		}
		});
	}

}

function updateQueryDetailPane(query){
	var detail = detailcaller.getdetail("detail_query");
	if (detail != undefined){
		if (query.listid == detail.temp_id){
			$(detail.content_wrapper).find('.cmd_xml').attr('href',query.link("xml"));
			$(detail.content_wrapper).find('.cmd_link').attr('href',query.link("fullpage"));
		}
	}
}
/*
function updateColumnsFromDetail(query){
	var detail = detailcaller.getdetail("detail_query");
	if (detail != undefined){
		if (query.listid == detail.temp_id){
			
			if (selectionlistset.getselectionlist(slid).autoSelected()){
				this.columns = "";
			} else
			{
				this.columns = selectionlistset.getselectionlist(slid).listwidget.getListText();
			}
		}
	}
}
*/