package eu.clarin.cmdi.mdservice.action;

import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;

import javax.servlet.http.HttpServletRequest;

import org.apache.log4j.Logger;
import org.apache.struts2.interceptor.ServletRequestAware;

import eu.clarin.cmdi.mdservice.internal.Admin;
import eu.clarin.cmdi.mdservice.internal.Cache;
import eu.clarin.cmdi.mdservice.internal.MDTransformer;
import eu.clarin.cmdi.mdservice.internal.NoStylesheetException;
import eu.clarin.cmdi.mdservice.model.Diagnostics;
import eu.clarin.cmdi.mdservice.model.WorkspaceProfile;

/**
 * main Struts2 controller (ie implemenets the struts' execute()-method), all other Actions are derived from.   
 * Defines the methods used for retrieving the data 
 * and provides basic implementation where possible.
 *  
 * @author vronk
 */
public class GenericProxyAction extends GenericAction 
implements ServletRequestAware 
{

	private static final long serialVersionUID = 1L;
	private static Logger log = Logger.getLogger("GenericProxyAction");
	
	private Diagnostics diagnostics;
	/** 
	 * Properties to be filled by Struts with according request-parameters
	 */	
	private String actionkey;
	private String q;
	private String squery;
	private String cache = Cache.USE;
	private String collection;
	private String columns;
	private String startItem;
	private String maximumItems;
	private String sort;
	private String lang="en";
	private int maxdepth;	
	private String format;
	private String options;
	private String actionContentType;
	private String userMsg;
	private String repository;
	//private Map<String,Object> session;
	private HttpServletRequest request; 
	private long duration = 0;
	private InputStream resultStream;
	private InputStream sourceStream;
	protected URL base_url ;
		
	 public GenericProxyAction(){
		 super();
		 initialize();
	 }
	 
	 public void setRepositoryByIndex(int id){
		
				net.sf.json.JSONArray json = WorkspaceProfile.getRepositories();
				if (json.size() > 0){
					repository = json.getJSONObject(id).getString("name");
				}
			
	 }
	 
	 protected void  initialize(){
		 //repository = 1;
		 setRepositoryByIndex(0);				
	 }
	 
	 
	 public Diagnostics getDiagnostics(){
		 return this.diagnostics;
	 }
	 
	 public void setDiagnostics(Diagnostics diagnostics){
		 this.diagnostics = diagnostics;
	 }
	 public Diagnostics Diagnostics(){
		 if (diagnostics == null){
			 diagnostics  = new Diagnostics();
		 }
		 return this.diagnostics;
	 }
	public String getQ() {
		return q;
	}

	public void setQ(String pq) {
		if (pq == null) pq="";
		/*
		if (q != null){
			if (q.trim().length() == 0){
				q = null;
			}
		}
		*/
		this.q = pq;
	}

	public String getSquery() {
		return squery;
	}

	public void setSquery(String psquery) {
		if (psquery==null) psquery="";
		this.squery = psquery;
	}
	
	public String getCache() {
		return cache;
	}

	public void setCache(String cache) {
		this.cache = cache;
	}

	public String getCollection() {
		return collection;
	}

	public void setCollection(String collection) {
		this.collection = collection;
	}
	
	//TODO defaults
	public String getColumns() {
		String cols = columns;
		/*if (columns == null){
			cols = "Id,Name,Title";
		}
		*/
		return cols;
	}

	public void setColumns(String columns) {
		this.columns = columns;
	}
	
	public int getMaxdepth() {
		return maxdepth;
	}

	public void setMaxdepth(int maxdepth) {
		this.maxdepth = maxdepth;
	}

	public String getFormat() {
		return format;
	}

	public void setFormat(String format) {
		this.format = format;
	}

	public String getOptions() {
		return options;
	}

	public void setOptions(String options) {
		this.options = options;
	}

	/**
	 * is used in struts.xml to dynamically set the mime-type of the result, depending on the format-parameter
	 * @return
	 */
	public String getActionContentType() {
		if (format.toLowerCase().startsWith("html")) {
			this.actionContentType = "text/html";		
			//this.actionContentType = "application/xhtml+xml";
		} else {
			this.actionContentType = "text/xml";
		}
		
		return actionContentType;
	}

	public void setActionContentType(String actionContentType) {
		this.actionContentType = actionContentType;
	}
	

	public void setRepository(String repository) {
		this.repository = repository;
	}
	
	public String getRepository() {
		//default repository = 1 (set on init)
		return repository;
	}
	public String getActionkey() {
		return actionkey;
	}

	public void setActionkey(String actionKey) {
		actionkey = actionKey;
	}

	
	public String getStartItem() {
		return startItem;
	}

	public void setStartItem(String startItem) {
		this.startItem = startItem;
	}

	public String getMaximumItems() {
		return maximumItems;
	}

	public void setMaximumItems(String maximumItems) {
		this.maximumItems = maximumItems;
	}
	

	public String getSort() {
		return sort;
	}

	public void setSort(String sort) {
		this.sort = sort;
	}

	public String getLang() {
		return lang;
	}

	public void setLang(String lang) {
		this.lang = lang;
	}

	public String getFullFormat() {		
		return actionkey + "2" + format;
	}

	/**
	 * internal identification of the target-proxy
	 * base for finding the right base_url in the properties
	 * subclass has to override with its specific proxykey
	 * @return the key identifying this type of proxy
	 */
	public String getProxyKey() {
		return "";
	}
	
	/**
	 * TODO: check what this does, where it is used?
	 * @return
	 */
	public String getUserMsg() {
		return userMsg;
	}

	public void setUserMsg(String userMsg) {
		this.userMsg = this.userMsg + "\n" + userMsg;
	}
	
	/**
	 * TODO: check what this does, where it is used?
	 * @return
	 */
	@Override
	public void setServletRequest(HttpServletRequest arg0) {
		request = arg0;
	}

	public HttpServletRequest getServletRequest() {
		return request;
	}

	/**
	 * The stream holding the resulting data to be sent back to the user as response
	 * @return
	 */
	public InputStream getResultStream() {
	        return resultStream;
    }
	public void setResultStream(InputStream _resultStream){
		resultStream = _resultStream;
	}
	public void setSourceStream(InputStream _sourceStream){
		sourceStream = _sourceStream;
	}
	
	/*
	public InputStream getSourceStream() throws IOException {
	        return getTargetRequest().openStream();
    }
*/
	
	
	/**
	 * Reads URI from the configuration (mdservice.properties) based on the proxy-key
	 * @return the base-URI of the target repository or registry
	 */
	public String getBaseURI() {		
		String uri =Admin.getConfig().getProperty(getProxyKey() + ".uri");		
		return uri;
	}

	/**
	 * Provides the base-URL specific to given target repository or registry 
	 * @return
	 * @throws MalformedURLException
	 */	
	public URL getBaseURL() throws MalformedURLException {		
		if (base_url == null) {
			base_url = new URL(getBaseURI());//Admin.getConfig().getProperty(getProxyKey() + ".uri"));
		}
		return base_url;
	}
	
	/**
	 * Constructs the actual URL to be send to the target repository/registry
	 * It has to be overridden by the subclasses 
	 * as every target service has a different request-pattern.  
	 * @return URL of the target request 
	 * @throws IOException
	 */
	public URL getTargetRequest() throws IOException {
		URL targetURL = getBaseURL();                      
        return targetURL;
	}
	
	/**
	 * Constructs an unambiguous key for the request (encoding all the parameters).
	 * This is used as identifier for caching 
	 * @return key unambiguously encoding the request
	 */
	
	 public String getRequestKey() {
			String key="";
			if (getActionkey()!=null) {
				key += getActionkey() + "//-" ;
			}else {
				key +="//-" ;
			}
			if (getQ()!=null) {
				key += getQ() + "//-" ;
			} else {
				key +="//-" ;
			}
			if (getCollection()!=null) {
				key += getCollection() + "//-";
			} else {
				key +="//-" ;
			}
			if (getSquery()!=null) {
				key += getSquery() + "//-" ;
			} else {
				key +="//-" ;
			}
			if (getStartItem()!=null) {
				key += getStartItem() + "//-";
			}
				else{
					key +="//-" ;
			}
			if (getMaximumItems()!=null) {
				key += getMaximumItems() + "//-";
			}
			else{
				key +="//-" ;
			}
			
			key += getRepository()  + "//-";
			key += getMaxdepth()  + "//-";
			
			if (getLang()!=null) {
				key += getLang() + "//-";
			}else{
				key +="//-" ;
			}			
			 
		return key;
	}
	 
	 
	public InputStream getSourceStream() throws IOException, NoStylesheetException {		
		return getTargetRequest().openStream();
 
	}
	
	
	
		public String addDurationKey(){
		String req_key = getRequestKey();
	
		Double duration_d;

	    duration_d = (double)duration; 
	    duration_d = duration_d/1000.0;
		req_key += duration_d + "//-";
		return req_key;
	}
	
	public HashMap<String,String> createTransformerParams(){
		
		HashMap<String,String> hm = new HashMap<String,String>();
		
	    if (getFullFormat() != null){
			hm.put("format", getFullFormat());
	    }
		if (getColumns() != null){
			hm.put("cols", getColumns());
		} else {
			hm.put("cols", "");
		}
		if (getStartItem() != null){
			hm.put("startItem", getStartItem());
		}
		if (getMaximumItems() != null){
			hm.put("maximumItems", getMaximumItems());	
		}
		if (getLang() != null){
			hm.put("lang", getLang());
		}
		if (getQ() != null){
		  	hm.put("q", getQ());
		}
		//if (getRepository() != null){
	        hm.put("repository_name", String.valueOf(getRepository()));
	        hm.put("repository_type", WorkspaceProfile.getRepositoryType(this.getRepository()));
		//}
        
		return hm;
		
	}
	
	/**
	 * This is the work-horse function.
	 * It does two things: 
	 * a) check if the source data is already in cache (based on cache-key that is constructed from the request parameters)
	 * b) if format-parameter provided, invokes the transformation. 
	 * at the end the data to be returned as result is contained in the resultStream
	 * If format is xml, then the data from sourceStream is passed further as resultStream. 
	 *    
	 * @throws Exception  This is handled by struts (is mapped to some result in struts.xml based on the Exception-Class)
	 */
	
	public void prepare() throws Exception {		
		
		String req_key = getRequestKey();
		Admin.notifyUser("request_key: " +  req_key); 
		Admin.notifyUser(getProxyKey() + ".targetURL: " + getTargetRequest() + " .format:" + getFullFormat());
		
		// Caching
		String xcid;
	
		// Admin.notifyUser("GPA.prepareSourceStream");
		
		if (getCache().equals(Cache.SKIP)) {
			
			sourceStream = getSourceStream();
			
		} else { 
			if (getCache().equals(Cache.USE)) {
					sourceStream = Cache.getCache().getFromCache(req_key);
			}
			if (sourceStream == null) { // either not in cache or cache_flag=refresh
				//sourceStream = getTargetRequest().openStream();
				long startMillis = System.currentTimeMillis();
				sourceStream = getSourceStream();
				duration = System.currentTimeMillis() - startMillis;
				req_key = addDurationKey();
				
				long now = System.currentTimeMillis();
				xcid = Cache.getCache().putInCache(req_key,sourceStream);			
				//Admin.notifyUser("putting in cache: " + req_key);			
				sourceStream = Cache.getCache().getFromCache(req_key);
			} /* else {
				Admin.notifyUser("reading from cache: " + req_key);
			} */
		}
			
		if (format.equals("xml")) {			
			resultStream = sourceStream;	
		}else {
			MDTransformer transformer = new MDTransformer();
			// set URL as srcFile (for MDTransformer to pass to xsl-scripts)
			// TODO: WHY??
			transformer.setSrcFile(getTargetRequest());
			transformer.setParams(createTransformerParams());
			// here the transformation is invoked
			resultStream = transformer.transformXML(sourceStream);
		}
			
		log.debug(getProxyKey() + " success:" + (resultStream!=null));
	}

	/**
	 * default Action method that gets called by Struts. Everything interesting happens in prepare()
	 */
	public String execute() throws Exception {
//		HttpServletRequest request = ServletActionContext.getRequest();

		
		//Admin.notifyUser("session-attrs:");
        //Admin.notifyUser(getServletRequest().getRemoteUser() );
        //Admin.notifyUser(String.valueOf(getSession()));
        
        long now = System.currentTimeMillis();

		prepare();
		long duration = (System.currentTimeMillis() - now);
		//duration

		if (resultStream == null) {
			return ERROR;	
		} else {
			return SUCCESS;
		}		
	}


}