package eu.clarin.cmdi.mdservice.action;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.StringWriter;
import java.io.UnsupportedEncodingException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import eu.clarin.cmdi.mdservice.internal.Cache;




public class SRUAction extends RepoAction 
{

	private static final long serialVersionUID = 1L;
	
	/** 
	 * Properties to be filled by Struts with according request-parameters
	 */	
	private String q;
	private String version;
	private String operation;
	private String query;
	private String scanClause;
	private int startRecord;
	private int maximumRecords;
	private String recordPacking;
	private String recordSchema;
	private String recordXPath;
	private int resultSetTTL;
	private String sortKeys;
	private String stylesheet;	
	private String x_cmd_repository;
	private String x_cmd_collections;
	private Set paramSet;

	
	private static int OP_SEARCHRETRIEVE = 1;
	private static int OP_EXPLAIN = 2;
	private static int OP_SCAN = 3;
	
	
	//TODO cache after analysis ?
	@Override
	public String getCache() {
		return Cache.SKIP;
	}
	
	private final static HashMap<String,String> hash_operations = new HashMap<String,String>();
	 static
	 {	 
		 hash_operations.put("searchRetrieve", "recordset");
		 hash_operations.put("explain", "model"); /* could be terms*/ 
		 hash_operations.put("scan", "values");
	 }
	 
	 private final static HashMap<String,Integer> operation_code = new HashMap<String,Integer>();
	 static
	 {	 
		 operation_code.put("searchRetrieve", OP_SEARCHRETRIEVE);
		 operation_code.put("explain", OP_EXPLAIN);
		 operation_code.put("scan", OP_SCAN);
	 }
	 
	 public SRUAction(){
		 super();
		 initialize();
	 }
	 
	 protected void  initialize(){
		 //repository = 1;
		 this.startRecord = 1;
		 this.maximumRecords = 50;
		 
		 if (getServletRequest() != null){
			 this.setX_cmd_repository(getServletRequest().getParameter("x-cmd-repository"));
			//this.setRepository(this.getX_cmd_repository());
			 paramSet = getServletRequest().getParameterMap().entrySet();			 
		 }
		 
	 }
	
	 public String getQ() {
			return q;
		}

		public void setQ(String q) {
			this.q = q;
		}
	 

	public String getVersion() {
		return version;
	}

	public void setVersion(String version) {
		this.version = version;
	}

	public String getOperation() {
		return operation;
	}

	public void setOperation(String operation) {
		this.operation = operation;
	}
	
	public String getQuery() {
		return query;
	}

	public void setQuery(String query) {
		this.query = query;
	}

	public String getScanClause() {
		return scanClause;
	}

	public void setScanClause(String scanClause) {
		this.scanClause = scanClause;
	}

	
	public int getStartRecord() {
		return startRecord;
	}

	public void setStartRecord(int startRecord) {
		this.startRecord = startRecord;
	}
	public int getMaximumRecords() {
		return maximumRecords;
	}

	public void setMaximumRecords(int maximumRecords) {
		this.maximumRecords = maximumRecords;
	}
	
	public String getRecordPacking() {
		return recordPacking;
	}

	public void setRecordPacking(String recordPacking) {
		this.recordPacking = recordPacking;
	}

	public String getRecordSchema() {
		return recordSchema;
	}

	public void setRecordSchema(String recordSchema) {
		this.recordSchema = recordSchema;
	}

	public String getRecordXPath() {
		return recordXPath;
	}

	public void setRecordXPath(String recordXPath) {
		this.recordXPath = recordXPath;
	}

	public int getResultSetTTL() {
		return resultSetTTL;
	}

	public void setResultSetTTL(int resultSetTTL) {
		this.resultSetTTL = resultSetTTL;
	}
	
	public String getSortKeys() {
		return sortKeys;
	}

	public void setSortKeys(String sortKeys) {
		this.sortKeys = sortKeys;
	}
		
	public String getStylesheet() {
		return stylesheet;
	}

	public void setStylesheet(String stylesheet) {
		this.stylesheet = stylesheet;
	}
	
	public String getX_cmd_repository(){
		return x_cmd_repository;
	}
	
	public void setX_cmd_repository(String x_cmd_repository){
		this.x_cmd_repository = x_cmd_repository;
	}

	public String getX_cmd_collections(){
		return x_cmd_collections;
	}
	
	public void setX_cmd_collections(String x_cmd_collections){
		this.x_cmd_collections = x_cmd_collections;
	}

	
	public String getDiagnosticStreamName() throws TransformerConfigurationException, UnsupportedEncodingException, ParserConfigurationException, TransformerException, TransformerFactoryConfigurationError{
		this.setResultStream(this.Diagnostics().buildXMLStream());
		return "resultStream";
	}
	/**
	 * primitive identification of the target-proxy
	 * base for finding the right base_url in the props
	 * subclass has to override with its specific proxykey
	 * @return
	 */
	public String getProxyKey() {
		return "";
	}
	/*
	@Override
	public String getBaseURI() {		
		Admin.notifyUser("SRU-repositorypath:" + WorkspaceProfile.getRepositoryPath(getRepository()));
		String uri = WorkspaceProfile.getRepositoryPath(getRepository());//Admin.getConfig().getProperty(getProxyKey() + ".uri");		
		return uri;
	}
	*/
	
	/* 
	public void prepareOperation() throws UnsupportedEncodingException{
		
		mdrepoproxyaction = new MDRepoProxyAction();
		mdrepoproxyaction.setDiagnostics(diagnostics);
		mdrepoproxyaction.setActionkey(hash_operations.get(this.getOperation()));
		
		// set the SRU extern property in proxyaction
		if (this.getX_cmd_repository() != null ) {
			mdrepoproxyaction.setRepository(this.getX_cmd_repository());
			//TODO\
			if (mdrepoproxyaction.getBaseURI() == null) this.Diagnostics().Add(Diagnostic.UNSUPPORTED_PARAMETERVALUE, "Unknown repository." + getX_cmd_repository());
		}
		
		if (operation.equals("searchRetrieve")){
			
			//query
			mdrepoproxyaction.setSquery("");
			if (this.query == null) {
				this.Diagnostics().Add(Diagnostic.MANDATORY_NOTSUPPLIED, "query");
				//return -1;
			}
			mdrepoproxyaction.setQ(getQuery());			
			mdrepoproxyaction.setFormat("xml");
			
			if ((this.startRecord < 0 ) ||((getServletRequest().getParameter("startRecord") != null)&&(getServletRequest().getParameter("startRecord").equals("0")))) {
				this.Diagnostics().Add(new Diagnostic(Diagnostic.UNSUPPORTED_PARAMETERVALUE, "startRecord must by grater than 0."));//,Diagnostic.NONFATALNONSURORGATE));
				//mdrepoproxyaction.setStartItem("1");
			} else {
				mdrepoproxyaction.setStartItem(Integer.toString(getStartRecord()));
			}
		
			if ((this.maximumRecords < 0 ) ||((getServletRequest().getParameter("maximumRecords") != null) && (getServletRequest().getParameter("maximumRecords").equals("0")))){
				   this.Diagnostics().Add(new Diagnostic(Diagnostic.UNSUPPORTED_PARAMETERVALUE, 
						   "maximumRecords must by greater than 0."));
			} else {
				mdrepoproxyaction.setMaximumItems(Integer.toString(this.getMaximumRecords()));	
			}
			
			if (this.getX_cmd_repository() != null ) {
				mdrepoproxyaction.setRepository(this.getX_cmd_repository());
				//TODO\
				if (mdrepoproxyaction.getBaseURI() == null) this.Diagnostics().Add(Diagnostic.UNSUPPORTED_PARAMETERVALUE, "Unknown repository." + getX_cmd_repository());
			}
			if (this.getX_cmd_collections() != null ) {
				mdrepoproxyaction.setCollection(this.getX_cmd_collections());
			}

		} else {
			if (operation.equals("explain") || operation == null){
				Admin.notifyUser("explaining", "debug");
			}else {
				if (operation.equals("scan")){
					if (this.scanClause == null) {
						this.Diagnostics().Add(Diagnostic.MANDATORY_NOTSUPPLIED, "scanClause");
						//return -1;
					} else{
						if (this.scanClause.equals("cmd.Collections")){
							
						} else {
							if (this.scanClause.equals("cmd.Repository")){
								XMLSerializer xmlserializer = new XMLSerializer();
								String xml = xmlserializer.write( WorkspaceProfile.getRepositories());//mdrepoproxyaction.getRepositories() );  
								this.setResultStream(new ByteArrayInputStream(xml.getBytes("UTF-8"))); 

							} else {
								
							}
						}
					}
				}else {
					this.Diagnostics().Add(Diagnostic.UNSUPPOERTED_OPERATION, "Only searchRetrieve,explain scan supported.");				}
			}
		}
	}
	
	public void sru2MD() throws UnsupportedEncodingException{
		// special handling of parameter setting, x-cmd-... not alowed in java
		this.setX_cmd_collections(getServletRequest().getParameter("x-cmd-collections"));		
		// root call own SRU SERVER
		//operation
		if (operation.equals("explain") || operation == null){
			// TODO: version param is mandatory for explain as well, but for root-request not!
			//explain
			termsproxyaction = new TermsProxyAction();
			termsproxyaction.setDiagnostics(diagnostics);
			termsproxyaction.setActionkey("terms");
			
			termsproxyaction.setQ("all");			
			termsproxyaction.setFormat("sru-explain");			
			
			//return -1;
		} else {				
			//version		
			if (this.version == null) {
				this.Diagnostics().Add(Diagnostic.MANDATORY_NOTSUPPLIED, "version");
				//return -1;
			} else {
				if (!version.equals("1.2")) {
					this.Diagnostics().Add(Diagnostic.UNSUPPORTED_VERSION, "Version 1.2 supported.");
					//return -1;
				}
			}
			
			prepareOperation();
		}
		
	}
	
	public void  prepareMD() throws Exception{
		sru2MD();
		if (Diagnostics().Accepted()){
			// root-explain
			if (this.termsproxyaction != null) {			
				if (this.termsproxyaction.execute() == SUCCESS){
					this.setResultStream(this.termsproxyaction.getResultStream());
					//return SUCCESS;
				}
			} else {
				//TODO diagnostic			 
				if (this.mdrepoproxyaction.getTargetRequest() == null) {
					Diagnostics().Add(Diagnostic.QUERYSYNTAXERROR);
					//return ERROR;
				}
				if (this.mdrepoproxyaction.execute() == SUCCESS){
					this.setResultStream(this.mdrepoproxyaction.getResultStream());
					postprocess();
					//return SUCCESS;
				}
			}
		}
		//return ERROR;
	}
	*/
/** TODO: move to Utils
 * 
 * @param stream
 * @return
 * @throws IOException
 */
	public static String inputStreamAsString(InputStream stream)
		throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(stream));
		StringBuilder sb = new StringBuilder();
		String line = null;

		while ((line = br.readLine()) != null) {
		sb.append(line + "\n");
		}

		br.close();
		return sb.toString();
	}

	 public static Document newDocumentFromInputStream(InputStream in) {
		    DocumentBuilderFactory factory = null;
		    DocumentBuilder builder = null;
		    Document ret = null;

		    try {
		      factory = DocumentBuilderFactory.newInstance();
		      builder = factory.newDocumentBuilder();
		    } catch (ParserConfigurationException e) {
		      e.printStackTrace();
		    }

		    try {
		      ret = builder.parse(new InputSource(in));
		    } catch (SAXException e) {
		      e.printStackTrace();
		    } catch (IOException e) {
		      e.printStackTrace();
		    }
		    return ret;
		  }


	public void postprocess() throws TransformerConfigurationException, UnsupportedEncodingException, ParserConfigurationException, TransformerException, TransformerFactoryConfigurationError{
		//recordPacking
		if (this.getRecordPacking() != null){
			if (this.getRecordPacking().toLowerCase().equals("string")){
				/*
				try {
					// FIXME: Which package is IOUTils from? 
					this.setResultStream(IOUtils.toInputStream(StringEscapeUtils.escapeXml(inputStreamAsString(this.getResultStream()))));
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}*/

			}
		}
		
		// add diagnostics
		if (Diagnostics().Exists()){
			Document doc = newDocumentFromInputStream(this.getResultStream());
			Node r_element=  doc.getElementsByTagName("searchRetrieveResponse").item(0);
			Document ddoc = Diagnostics().buildXMLDocument();
			Node d_element=  ddoc.getElementsByTagName("diagnostics").item(0);
			doc.adoptNode(d_element);
			r_element.appendChild(d_element);
			DOMSource source = new DOMSource(doc);   
			StringWriter xmlAsWriter = new StringWriter();   
			StreamResult result = new StreamResult(xmlAsWriter);    
			TransformerFactory.newInstance().newTransformer().transform(source, result);
			this.setResultStream(new ByteArrayInputStream(xmlAsWriter.toString().getBytes("UTF-8")));
		}
	}
	
	//TODO create query + query.toURLParams ?
	public String createURLParams(){
		String params = "";
		
		//TODO params
		if (paramSet == null){
			if (!(operation == null)){
				params = params + "operation=" + operation;
			}
			if (!(version == null)){
				params = params + "&version=" + version;
			}
			if (!(query == null)){
				params = params + "&query=" + query;
			}
			if (getStartRecord() > 0){
				params = params + "&startRecord=" + String.valueOf(getStartRecord());
			}
			if (getMaximumRecords()> 0){
				params = params + "&numRecords=" + String.valueOf(getMaximumRecords());
			}
		} else {
			Iterator i = paramSet.iterator();
			params = "";
		    while(i.hasNext()){
			      Map.Entry me = (Map.Entry)i.next();
			      if (!(me.getKey().equals("x-cmd-repository") || me.getKey().equals("x-cmd-collections"))){
				      params = params + "&" + me.getKey() + "=" + ((String[])me.getValue())[0];  
			      }
			}
		    params = params.substring(1);

		}

		return params;
	}
	

/*	
	@Override 
	public void prepare() throws Exception{
		//this.setX_cmd_repository(getServletRequest().getParameter("x-cmd-repository"));
		//this.setRepository(this.getX_cmd_repository());
		//TODO xsl usage according particular repositories ?
		//this.setActionkey("sru");
		//this.setFormat("xml");
		
		//extern SRU repository
		if (WorkspaceProfile.isSRURepository(getRepository()) || this.getBaseURI() == null){
			super.prepare();
		}
		else {
			 prepareMD();
		}
		
	}
*/
	
}