package eu.clarin.cmdi.mdservice.model;

import java.io.StringWriter;

import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import eu.clarin.cmdi.mdservice.internal.Admin;
import eu.clarin.cmdi.mdservice.action.DCRProxyAction;


public class SearchClauses{
	private String xml_string;
	private Document xml_document;
	private SearchClause[][] list;
	
	
	public SearchClauses(Document _doc){
		list = new SearchClause[20][20];
		
		for(int i=0;i<20;i++){
			for(int j=0;j<20;j++){
				list[i][j]=null;
			}
		}
		xml_document=  _doc;
		Admin.notifyUser("SCCCCC: constuctor");
		deserialize();
		// do processing
	}
	
	// create array from xml_document
	private int getLastAnd(){
		for(int i=0; i< 20;i++){
			if (list[i][0] == null) return i;
		}
		return 0;
	}
	private int getLastOr(int i){
		for(int j=0;j< 20;j++){
			if (list[i][j] == null) return j;
		}
		return 0;
	}
	
	private void deserialize(Node node, int level){
		NodeList nodeList;
		String b;
		SearchClause sc;
		int or_last;
		
		if (node.getNodeName().equals("tripple")){
			nodeList = node.getChildNodes();
			b = nodeList.item(0).getFirstChild().getNodeValue();
			deserialize(b,nodeList.item(1), nodeList.item(2), level);
		}else{
			if (node.getNodeName().equals("searchClause")){
				nodeList = node.getChildNodes();
				sc = new SearchClause(nodeList.item(0).getNodeValue(), nodeList.item(1).getFirstChild().getNodeValue(), nodeList.item(2).getNodeValue());
				or_last = getLastOr(level);
				list[level][or_last] = sc;
			}
		}

	}
	private void deserialize(String rel, Node left, Node right, int and_level){
		String b;
		NodeList nodeList;
		SearchClause sc;
		int and_last;
		
		if (rel.equals("and")) {
			deserialize(left, and_level);
			and_last = getLastAnd();
			deserialize(right, and_last);			
		}
		if (rel.equals("or")) {
			deserialize(left, and_level);
			deserialize(right, and_level);
		}
		
	}
	private void deserialize(){
		Node node;
		NodeList nodeList;
		String b;
		SearchClause sc;
		
		node = xml_document.getFirstChild();
		if (node.getNodeName().equals("tripple")){
			nodeList = node.getChildNodes();
			b = nodeList.item(0).getFirstChild().getNodeValue();
			deserialize(b,nodeList.item(1), nodeList.item(2),0);
		}else{
			Admin.notifyUser("SCCCCC: deserialize");
			if (node.getNodeName().equals("searchClause")){
			
				nodeList = node.getChildNodes();
				sc = new SearchClause(nodeList.item(1).getTextContent().trim(), nodeList.item(3).getTextContent().trim(), nodeList.item(5).getTextContent().trim());
				list[0][0] = sc;
			}
		}
		Admin.notifyUser("SCCCCC: list " + list[0][0].getIndex() + list[0][0].getValue());
		
		
	}
	
	// create xml_document from array-list
	// create xml-string from xml_document
	private Element serialize(SearchClause sc){
		Element e, root, e_rel;
		
		root = xml_document.createElement("searchClause");
		e = xml_document.createElement("index");
		e.setNodeValue(sc.getIndex());
		root.appendChild(e);
		e_rel = xml_document.createElement("relation");
		//e.setNodeValue(list[0][0].getRelation());
		root.appendChild(e_rel);
		e = xml_document.createElement("term");
		e.setNodeValue(sc.getValue());
		root.appendChild(e);
		
		e = xml_document.createElement("value");
		e.setNodeValue(sc.getValue());
		e_rel.appendChild(e);
		
		return root;
	}
	
	private Element serialize(Element e1, Element e2, String operand){
		Element e, root, e_rel;
		
		root = xml_document.createElement("tripple");
		e_rel = xml_document.createElement("boolean");
		e = xml_document.createElement("value");
		e.setNodeValue(operand);
		e_rel.appendChild(e);
		root.appendChild(e_rel);

		e = xml_document.createElement("leftOperand");
		e.appendChild(e1);
		root.appendChild(e);
		
		e = xml_document.createElement("rightOperand");
		e.appendChild(e2);
		root.appendChild(e);
		
		return root;
	}
	
	private void serialize(){
		Node node;
		Element root, e, e_rel, ej, ej_last = null;
		
		// remove old document
		Admin.notifyUser("SCCCCC: serialize");
		Admin.notifyUser("SCCCCC: " + xml_document.getChildNodes().getLength());
		xml_document.removeChild(xml_document.getFirstChild());
		Admin.notifyUser("SCCCCC: CLEARED " + xml_document.getChildNodes().getLength());
		
		if ((getLastAnd() == 1) && (getLastOr(0) == 1)){
			Admin.notifyUser("SCCCCC: searchClause ");
			root = xml_document.createElement("searchClause");
			e = xml_document.createElement("index");
			e.setTextContent(list[0][0].getIndex());
			root.appendChild(e);
			e_rel = xml_document.createElement("relation");
			root.appendChild(e_rel);
			e = xml_document.createElement("term");
			e.setTextContent(list[0][0].getValue());
			root.appendChild(e);
			
			e = xml_document.createElement("value");
			e.setTextContent(list[0][0].getRelation());
			e_rel.appendChild(e);
			
		} else {
			root = xml_document.createElement("tripple");
			
			for(int i=0;i<20;i++){
				if (list[i][0] == null){
					break;
				}
				ej = serialize(list[i][0]);
				for(int j=1;j<20;j++){
					if (list[i][j] == null){
						break;
					}
					e = serialize(list[i][j]);
					ej = serialize(ej,e,"or");
				}
				if (ej_last != null){
					ej_last = serialize(ej_last, ej, "and");
				}
				ej_last = ej;
			}
		}
        xml_document.appendChild(root);

		
		////////////////// to XML-string
		
        
      //set up a transformer
        TransformerFactory transfac = TransformerFactory.newInstance();
        Transformer trans;
		try {
			trans = transfac.newTransformer();
			trans.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes");
	        trans.setOutputProperty(OutputKeys.INDENT, "yes");

	        //create string from xml tree
	        StringWriter sw = new StringWriter();
	        StreamResult result = new StreamResult(sw);
	        DOMSource source = new DOMSource(xml_document);
	        try {
				trans.transform(source, result);
			} catch (TransformerException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
	        xml_string = sw.toString();
	        Admin.notifyUser("SERIALIZED-XML:  " + xml_string);
		} catch (TransformerConfigurationException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
        

	}
	
	public String toXML(){
		serialize();
		return xml_string;
	}
	
	//TODO processing
	// replace ISOCAT - category by elements
	// optimize
	// remove duplicates
	
	public void process(){
		DCRProxyAction a = new DCRProxyAction();
		//TODO format, actionkey - 
		
		try {
			//a.execute();
			//TODO update list structure according ELEMENTS
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		//insert into a[i]
		
		
	}
	
}
