package eu.clarin.cmdi.mdservice.model;

import java.util.HashMap;

import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import eu.clarin.cmdi.mdservice.internal.Admin;

public class Termset {

	private final static HashMap<String,Object> termsets = new HashMap<String,Object>();
	
	private final HashMap<String,String> attrs = new HashMap<String,String>();
	
	public Termset () {		
	}

	public Termset (Node n) {
		this.setAttrs(n);
	}
	
	public void setAttrs(Node n) {
	
			for (int i=0; i < n.getAttributes().getLength(); i++) {
				String key = n.getAttributes().item(i).getNodeName();
				String value = n.getAttributes().item(i).getNodeValue();
				attrs.put(key, value);
			}		
	}
	
	public String getAttr(String key) {
	  return attrs.get(key);
	}

	public static HashMap<String, Object> getTermsets() {
		if (termsets.size() == 0) {
			initTermsets();			
		}
		return termsets;
	}

	public static Termset getTermset(String ts_id) {		
		
		Termset res = (Termset) getTermsets().get(ts_id);
		if (res==null) Admin.notifyUser("getTermset(): no termset found for:" + ts_id);
		//else
			//Admin.notifyUser("getDCR():" + res.getAttr("id") + ":" + res.getAttr("url") );		
		return res;
	}
	
	public static String getTermsetAttr(String ts_id, String key) {	
		Termset ts = getTermset(ts_id);
		String val=""; 
		if (ts!=null) val= ts.getAttr(key);
		 return val;
	}

	public static void initTermsets() {
			Document dcrs_setup = Admin.getXMLDocument(Admin.getConfig().getProperty("terms.file"));
		
		//	Admin.loadFile(Admin.getConfig().getProperty("service.list.file"));		 
			Admin.notifyUser("initTermsets().loaded.");					
			//.getDocumentElement().getLocalName()
			//Document chains_doc = Admin.getXMLDocument(Admin.getConfig().getProperty("chains.file"));
	
			//Admin.notifyUser("formPath:xpath:"+xpath_expr);
			//creating an XPathFactory:
	        XPathFactory factory = XPathFactory.newInstance();
	        //using this factory to create an XPath object: 
	        XPath xpath = factory.newXPath();
	        //XPath object created compiles the XPath expression: 
	        XPathExpression expr;
			try {
				expr = xpath.compile("//Termset");
				//expression is evaluated with respect to a certain context node which is doc.
		        Object result = expr.evaluate(dcrs_setup, XPathConstants.NODESET);
		        NodeList list = (NodeList) result;
	
		        // <Termset type="dcr" id="isocat" label="isoCAT" url="http://www.isocat.org/rest/" format="dcif" />
		        for (int i = 0; i<list.getLength();i++) {
		        	//String value = list.item(i).getTextContent();
		        	Node n = list.item(i);	        	    	
		        	Termset ts = new Termset(n);        		
		        	 	        	
		        	Admin.notifyUser("reading in Termset: " + ts.getAttr("id"));
		        	termsets.put(ts.getAttr("id"), ts );
		        }    
			} catch (XPathExpressionException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

	}
	
	
}
