<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet
  version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:my="myFunctions">
<!-- 
<purpose> convert fsls to html-list-snippet</purpose>
<params>
<param name=""></param>
</params>
<history>
	<change on="2010-06-22" type="created" by="vr">based on fsls2view.xsl</change>		
</history>
<sample> result
	<ul id="browser" class="filetree treeview-famfamfam treeview">
		<li><span class="folder">Folder 1</span>
			<ul>
				<li><span class="folder">Item 1.1</span>
					<ul>
</sample>
-->

<xsl:import href="cmd_commons.xsl" />

<!-- <xsl:output method="xml" />  -->

<xsl:param name="max_depth">0</xsl:param>
<xsl:param name="sort">name</xsl:param> <!-- s=size|n=name|t=time -->
<xsl:param name="style_dir" />
<xsl:param name="basedir" >../..</xsl:param>
<xsl:param name="format" />

<xsl:decimal-format name="european" decimal-separator=',' grouping-separator='.' />

<xsl:param name="title" >Collections Index: <xsl:value-of select="/Collections/@root"/></xsl:param>

<xsl:template name="callback-header" >
	<style type="text/css">
		#collectionstree { margin-left: 10px; border: 1px solid #9999aa; border-collapse: collapse;}
		.number { text-align: right; }
		td { border-bottom: 1px solid #9999aa; padding: 1px 4px;}
		.treecol {padding-left: 1.5em;}
		table thead {background: #ccccff; font-size:0.9em; }
		table thead tr th { border:1px solid #9999aa; font-weight:normal; text-align:left; padding: 1px 4px;}
}  
	</style> 
	<script type="text/javascript" >
		$(function(){
			$("#collectionstree").treeTable();
		});
	</script>
</xsl:template>

<xsl:template name="continue-root" >
<xsl:choose> 			   	 	
	   	<xsl:when test="$format='collection2htmlpage'" >    	 					      
			    <div id="collections">
					<table id="collectionstree" >
						<thead>
						<tr><th class="treecol">Name</th><th>Count (visible) Subcoll</th><th>Count Resources</th><th>Handle</th></tr>
						</thead>					
						<xsl:apply-templates select="*/c" mode="detail">
							<xsl:sort order="ascending" select="@n" />							
						</xsl:apply-templates>
					</table>
				</div>	    	 				    		
	  	 	</xsl:when>
     	<xsl:otherwise>
    	 		<!-- <div>
    	 		 -->
    	 		
					 <ul class="treeview">
						<xsl:apply-templates select="*" >
							<xsl:sort order="ascending" select="@n" />							
					</xsl:apply-templates>			
					</ul>
				<!-- </div>
				 -->	
	   	 </xsl:otherwise>
   	</xsl:choose>
	
</xsl:template>
<!-- treeview -->
<xsl:template match="c" >
	<xsl:variable name="lv" select="count(ancestor::c)" />
	<xsl:variable name="root" select="/Collections/@root" />
    	 		
	<xsl:choose>
	<xsl:when test="($lv&gt;0) or $root='root'">	
	<li>
		<xsl:attribute name="class">
						<xsl:choose>
					<xsl:when test="@cnt_subcolls=0">jstree-leaf</xsl:when>
					<xsl:otherwise>jstree-closed</xsl:otherwise>
				</xsl:choose>					
		</xsl:attribute>
  		<xsl:attribute name="handle">
  		<xsl:value-of select="@handle"/>		
		</xsl:attribute>
			 <span class="cmd cmd_load"> </span>
	  
	 <!-- 
	 <label class="showselection" count="0" some_selection="0" >o</label>
	 <input type="checkbox" class="selection" child="undefined" />
	 <span class="folder" >
     	<xsl:attribute name="handle">
    	<xsl:value-of select="@handle"/>
  		</xsl:attribute>
  		<a href="{my:formURL('record','htmldetail', @handle )}" ><xsl:value-of select="@n" /></a></span>  		
     <span class="note"> |<xsl:value-of select="@cnt" />|</span><span class="cmd cmd_detail"> </span> 
	  -->    
     <a href="{my:formURL('record','htmldetail', @handle )}" ><xsl:value-of select="@n" /></a>

		<xsl:if test="c and ($lv&lt;$max_depth or $max_depth=0)">
			<ul>
				<xsl:choose>
					<xsl:when test="$sort='s'">				
						<xsl:apply-templates select="c" >
								<xsl:sort order="descending" select="@cnt" data-type="number" />
						</xsl:apply-templates>		
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="c" >
								<xsl:sort order="ascending" select="@n" />
						</xsl:apply-templates>		
					</xsl:otherwise>
				</xsl:choose>					
			</ul>
		
		</xsl:if>
	</li>
	</xsl:when>
	<xsl:otherwise>
			<xsl:if test="c and ($lv&lt;$max_depth or $max_depth=0)">
			
				<xsl:choose>
					<xsl:when test="$sort='s'">				
						<xsl:apply-templates select="c" >
								<xsl:sort order="descending" select="@cnt" data-type="number" />
						</xsl:apply-templates>		
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="c" >
								<xsl:sort order="ascending" select="@n" />
						</xsl:apply-templates>		
					</xsl:otherwise>
				</xsl:choose>					
		
		</xsl:if>
	
	</xsl:otherwise>
	</xsl:choose>
</xsl:template>
<!--  old version treeview

<xsl:template match="c" >
	<xsl:variable name="lv" select="count(ancestor::c)" />
	
	<li>
		<xsl:attribute name="class">
						<xsl:choose>
					<xsl:when test="@cnt_subcolls=0">				
						jstree-leaf	
					</xsl:when>
					<xsl:otherwise>
						jstree-closed
					</xsl:otherwise>
				</xsl:choose>					
		</xsl:attribute>
  		<xsl:attribute name="handle">
  		<xsl:value-of select="@handle"/>		
		</xsl:attribute>
			 <span class="cmd cmd_load"> </span>
	 <label class="showselection" count="0" some_selection="0" >o</label> 
	 <input type="checkbox" class="selection" child="undefined" />    
     <span class="folder" >
     	<xsl:attribute name="handle">
    	<xsl:value-of select="@handle"/>
  		</xsl:attribute>
  		<a href="{my:formURL('record','htmldetail', @handle )}" ><xsl:value-of select="@n" /></a></span>  		
     <span class="note"> |<xsl:value-of select="@cnt" />|</span><span class="cmd cmd_detail"> </span> 
		
		<xsl:if test="c and ($lv&lt;$max_depth or $max_depth=0)">
			<ul>
				<xsl:choose>
					<xsl:when test="$sort='s'">				
						<xsl:apply-templates select="c" >
								<xsl:sort order="descending" select="@cnt" data-type="number" />
						</xsl:apply-templates>		
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="c" >
								<xsl:sort order="ascending" select="@n" />
						</xsl:apply-templates>		
					</xsl:otherwise>
				</xsl:choose>					
		</ul>
		
	</xsl:if>
	</li>
</xsl:template>
 -->
 
<xsl:template match="c" mode="detail" >
<xsl:param name="parentid" select="'c-'" />

<xsl:variable name="lv" select="count(ancestor::c)" />

	<xsl:variable name="cid" >
		<xsl:choose>
		<xsl:when test="$lv=0"><xsl:value-of select="concat($parentid,position())" /></xsl:when>
		<xsl:otherwise><xsl:value-of select="concat($parentid,'-', position())" /></xsl:otherwise>
		</xsl:choose> 
	</xsl:variable>
	
	<tr id="{$cid}" >
	  <xsl:if test="$lv!=0" >
	  	<xsl:attribute name="class" select="concat('child-of-',$parentid)" />
	  </xsl:if>
		<td class="treecol" ><xsl:value-of select="@n" /></td>		
		<td class="number"><xsl:value-of select="count(.//c)" /></td>
		<td class="number"><xsl:value-of select="@cnt" /></td>
		<td><xsl:value-of select="@handle" /></td>			
     </tr> 
		<xsl:if test="c and ($lv&lt;$max_depth or $max_depth=0)">
			
				<xsl:choose>
					<xsl:when test="$sort='s'">				
						<xsl:apply-templates select="c" mode="detail">
							<xsl:with-param name="parentid" select="$cid" />			
								<xsl:sort order="descending" select="@cnt" data-type="number" />
						</xsl:apply-templates>		
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="c" mode="detail">
							<xsl:with-param name="parentid" select="$cid" />
								<xsl:sort order="ascending" select="@n" />
						</xsl:apply-templates>		
					</xsl:otherwise>
				</xsl:choose>					
					
		</xsl:if>
	
</xsl:template>


</xsl:stylesheet>