<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet
  version="2.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xs="http://www.w3.org/2001/XMLSchema"
  xmlns:my="myFunctions"
  	xmlns:dcif="http://www.isocat.org/ns/dcif"
 >
<!-- 
<purpose> generate a termMatrix out of all datcats based on terms_setup.xml  </purpose>
<strategy>fetch and concat the individual Termsets </strategy>
<params>
<param name=""></param>
</params>
<history>
	<change on="2010-10-10" type="created" by="vr"></change>
</history>
-->
<xsl:import href="cmd_commons.xsl"/>

<xsl:output method="xml" indent="yes" > </xsl:output>

<xsl:param name="title" select="'Datcat terms all'"></xsl:param>

<xsl:template name="continue-root">
	<xsl:apply-templates  />
</xsl:template>

<xsl:template match="dcif:dataCategorySelection" >

</xsl:template>

<xsl:template match="Termsets" >
	<xsl:copy>
		<xsl:message>count dcr/rd termsets:<xsl:value-of select="count(Termset[@type='dcr' or @type='rr'])" /></xsl:message>
		<xsl:apply-templates select="Termset[@type='dcr' or @type='rr']" />
	</xsl:copy>
</xsl:template>

<xsl:template match="Termset" >
	<xsl:variable name="resolved_termset_uri" select="concat($datcats_terms_uri,@id)" />
	
	<xsl:variable name="termset" select="document($resolved_termset_uri)" />
	
	<xsl:copy>
		<xsl:copy-of select="@*" />
		<xsl:copy-of select="$termset/Termset/*" />			
	</xsl:copy>
	
</xsl:template>

</xsl:stylesheet>
