<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet
  version="2.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xs="http://www.w3.org/2001/XMLSchema"
  xmlns:my="myFunctions"
  xmlns:owl="http://www.w3.org/2002/07/owl#" 
  xmlns:skos="http://www.w3.org/2004/02/skos/core#" xmlns:dcam="http://purl.org/dc/dcam/" xmlns:dcterms="http://purl.org/dc/terms/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#"
>
<!-- 
<purpose> generate a termMatrix for a datcat-profile (rdf-based = dublincore: http://dublincore.org/2008/01/14/dcelements.rdf#)</purpose>
<strategy>map from rdf to Terms </strategy>
<params>
<param name=""></param>
</params>
<history>
	<change on="2010-10-10" type="created" by="vr"></change>
</history>
-->
<xsl:import href="cmd_commons.xsl"/>

<xsl:output method="xml" indent="yes" > </xsl:output>

<xsl:param name="title" select="'Datcat terms'"></xsl:param>

<xsl:template name="continue-root">

	<xsl:message>continue in :<xsl:value-of select="name()" /></xsl:message>
			<xsl:choose>    	 	
	    	 	 <xsl:when test="contains($format,'rr-rdf')" >
	    	 	 <xsl:message>count rels:<xsl:value-of select="count(/rdf:RDF/rdf:Description)" /></xsl:message>    	 						
	    	 	 <xsl:message>src_file:<xsl:value-of select="$src_file" /></xsl:message>
	    	 	 <xsl:message>root_uri:<xsl:value-of select="$root_uri" /></xsl:message>
  	    	 		<xsl:call-template name="rr" />    	 		    
	    	 	</xsl:when>
	    	 	 <xsl:when test="//rdf:Property" >
	    	 	 	<xsl:message>count terms:<xsl:value-of select="count(//rdf:Property)" /></xsl:message>	    	 	
					<xsl:apply-templates select="/rdf:RDF/rdf:Description" mode="init" />
				</xsl:when>				
	    	 	<xsl:otherwise>
	    	 			<xsl:apply-templates select="/rdf:RDF/rdf:Description[1]"  mode="init" />
				</xsl:otherwise>
			</xsl:choose>
</xsl:template>

<xsl:template match="rdf:Description" mode="init" >
	<Termset id="{@rdf:about}" label="{dcterms:title}" >
		<!-- different structures in:  
			dcelements: -->
		<xsl:apply-templates select="/rdf:RDF/rdf:Property" />
		<!-- and dcterms: -->
		<xsl:apply-templates select="/rdf:RDF/rdf:Description[position() &gt; 1]" mode="dcterm" />
		
	</Termset>
</xsl:template>

<xsl:template name="rr">
	<xsl:variable name="rrroot"  select="rdf:RDF" />
 <Termset type="rr" >
  <!--  TODO: we have to match on ID/url! -->
 	<xsl:copy-of select="$terms_setup//Termset[@type='rr']/@*"  />
	<xsl:for-each select="distinct-values(.//@rdf:about)" > <!--  .//@rdf:resource| -->
		<xsl:variable name="datcat1" select="." />	
		<Term type="rel" datcat="{$datcat1}"  >		
			<xsl:for-each select="$rrroot/rdf:Description[@rdf:about=$datcat1]" >		
				<Term type="rel" reltype="{name(*[1])}" datcat="{*/@rdf:resource}" />				
			</xsl:for-each>
			<!--  <xsl:for-each select="$rrroot/rdf:Description[*/@rdf:resource=$datcat1]" >
				<Term type="rel"  name="y" ref="{@rdf:about}" />				
			</xsl:for-each> -->		
		 </Term>
	</xsl:for-each>
</Termset>

</xsl:template>


<!-- <Term elem="TextCorpusProfile" datcat="" corresponding_component="" parent="" context=".TextCorpusProfile" 
name="TextCorpusProfile" count="8" count_text="199" count_distinct_text="87" path="TextCorpusProfile"/>
 -->
<xsl:template match="rdf:Property" >
	<Term type="datcat" name="{rdfs:label}" datcat="{@rdf:about}" id="{@rdf:about}">
		<xsl:for-each select="*" >
			<xsl:element name="{name()}" ><xsl:value-of select="." /></xsl:element>			
		</xsl:for-each>
	</Term>
</xsl:template>

<xsl:template match="rdf:Description" mode="dcterm" >
	<Term type="datcat" name="{rdfs:label}" datcat="{@rdf:about}" id="{@rdf:about}">
		<xsl:for-each select="*" >
			<xsl:element name="{name()}" ><xsl:value-of select="." /></xsl:element>			
		</xsl:for-each>
	</Term>
</xsl:template>

</xsl:stylesheet>
