﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet
  version="2.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<!-- 
<purpose> convert fsls to html-list-snippet</purpose>
<params>
<param name=""></param>
</params>
<history>
	<change on="2009-11-15" type="created" by="vr">based on fs_view.xsl</change>	
	<change on="2010-01-17" type="changed" by="vr">added hack: replace .xml -> .html (in name)</change>	
	<change on="2010-03-28" type="created" by="vr">based on fsls2htmllist.xsl</change>	
</history>
<sample> result
	<ul id="browser" class="filetree treeview-famfamfam treeview">
		<li><span class="folder">Folder 1</span>
			<ul>
				<li><span class="folder">Item 1.1</span>
					<ul>
</sample>
-->

<xsl:import href="cmd_commons.xsl" />

<xsl:param name="size_lowerbound">0</xsl:param>
<xsl:param name="max_depth">2</xsl:param>
<xsl:param name="show">file</xsl:param> <!-- file -->
<xsl:param name="sort">name</xsl:param> <!-- s=size|n=name|t=time -->
<xsl:param name="style_dir" />
<xsl:param name="name_col_width" >50%</xsl:param>
<xsl:param name="basedir" >../..</xsl:param>

<xsl:param name="format" />

<xsl:decimal-format name="european" decimal-separator=',' grouping-separator='.' />

<xsl:param name="title" >Index: <xsl:value-of select="/d/@n"/></xsl:param>

<xsl:template name="continue-root" >
	<div>
	<ul class="filetree treeview">
		<xsl:apply-templates select="*" >							
		</xsl:apply-templates>			
	</ul>
	</div>
</xsl:template>

<xsl:template match="d" >
	<xsl:variable name="lv" select="count(ancestor::d)" />
	
	<li><span class="folder"><xsl:value-of select="@n" /></span>		
	
		<xsl:if test="$lv&lt;$max_depth or $max_depth=0">
			<ul>
				<xsl:choose>
					<xsl:when test="$sort='s'">				
						<xsl:apply-templates select="d[sum(.//f/@s[.!=''])&gt;=$size_lowerbound]" >
								<xsl:sort order="descending" select="sum(.//f/@s[.!=''])" data-type="number" />
						</xsl:apply-templates>		
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="d[sum(.//f/@s[.!=''])&gt;=$size_lowerbound]" >
								<xsl:sort order="ascending" select="@*[name()=$sort]" />
						</xsl:apply-templates>		
					</xsl:otherwise>
				</xsl:choose>
				
				
				<xsl:if test="contains($show,'file')" >
					<xsl:choose>
						<xsl:when test="$sort='s'">				
							<xsl:apply-templates select="f[@s&gt;$size_lowerbound or @s='']" >
								<xsl:sort order="descending" data-type="number" select="@s" />
							</xsl:apply-templates>
						</xsl:when>
						<xsl:otherwise>
							<xsl:apply-templates select="f[@s&gt;$size_lowerbound or @s='']" >
									<xsl:sort order="ascending" select="@*[name()=$sort]" />
							</xsl:apply-templates>
						</xsl:otherwise>
					</xsl:choose>
					
				</xsl:if>
				
		</ul>
		
	</xsl:if>
	</li>
</xsl:template>

<xsl:template match="f">
<xsl:variable name="href" ><xsl:call-template name="path"/>
	</xsl:variable>
	
	
	<li><span class="{@x}">
		<a target="detail">
				<xsl:attribute name="href" ><xsl:call-template name="fn" /></xsl:attribute>
					<xsl:call-template name="fn" /></a>
		</span></li>	
</xsl:template>

<xsl:template name="fn" >
	<xsl:choose>
		<xsl:when test="ends-with(@n,'.xml')" >
				<xsl:value-of select="concat(substring-before(@n,'.xml'),'.html')" />
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="@n" />
		</xsl:otherwise>
	</xsl:choose>
	
</xsl:template>


<xsl:template name="dir" >
	<xsl:for-each select="ancestor::d" ><xsl:value-of select="@n" />/</xsl:for-each>	
</xsl:template>

<xsl:template name="path" >
	<xsl:text>file://</xsl:text><xsl:value-of select="$basedir" />/<xsl:call-template name="dir"/><xsl:value-of select="@n" />		
</xsl:template>


</xsl:stylesheet>