﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet
  version="2.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:my="myFunctions"
>
<!-- 
<purpose> generate a view for a model summary (generated by model_stats.xq</purpose>
<params>
<param name=""></param>
</params>
<history>
	<change on="2010-01-08" type="created" by="vr">from cmd2stats.xsl</change>	
	<change on="2010-03-27" type="changed" by="vr">include cmd_commons.xsl</change>	
</history>
-->
<xsl:import href="cmd_commons.xsl"/>
<xsl:import href="model2matrix.xsl"/>


<!-- <xsl:param name="size_lowerbound">0</xsl:param>
<xsl:param name="max_depth">0</xsl:param>
<xsl:param name="freq_limit">20</xsl:param>
<xsl:param name="show">file</xsl:param> -->
<xsl:param name="sort">x</xsl:param> <!-- s=size|n=name|t=time|x=default -->
<xsl:param name="name_col_width" >50%</xsl:param>

<!-- <xsl:param name="mode" select="'htmldiv'" /> -->
<xsl:param name="title" select="'Terms'" />

<!--
<xsl:param name="detail_uri_prefix"  select="'?q='"/> 
-->
<xsl:output method="html" /> 


<xsl:decimal-format name="european" decimal-separator=',' grouping-separator='.' />

<xsl:template name="continue-root">

		<xsl:variable name="termmatrix">
			<xsl:apply-templates mode="matrix" />
		</xsl:variable>
		
		<xsl:for-each select="$termmatrix" >
			<xsl:call-template name="continue" />
		</xsl:for-each>

</xsl:template>

<xsl:template name="continue">
	<div>	
		<xsl:choose>    	 	
    	 	 <xsl:when test="$format='model2htmltable'" >
    	 		<xsl:call-template name="header"/>    
    	 		<xsl:call-template name="table"/>
    	 		    
    	 	</xsl:when>
    	 	<xsl:when test="$format='model2htmlpage'" >
    	 		<xsl:call-template name="header"/>
			    <div id="model">
			    	<xsl:call-template name="terms-tree" />
			    	<xsl:call-template name="list-datcats" />
					<!-- <table id="modeltree" >
						<thead>
						<tr><th class="treecol">Name</th><th>Count Elems</th><th>Count Text</th><th>Count Distinct Text</th><th>Path</th><th>comp/datcat</th></tr>
						</thead>					
						<xsl:apply-templates select="*/Term" mode="detail">
							<xsl:sort order="ascending" select="@n" />							
						</xsl:apply-templates>
					</table>  -->
				</div>	    	 
								    		
	  	 	</xsl:when>	  	 	     	
    	 	<xsl:when test="$format='model2htmllist'" >    	 		
    	 		<xsl:call-template name="list"/>    
    	 	</xsl:when>
    	 	<xsl:when test="$format='model2htmlselect'" >    	 					      
			      		<select id="terms-select">		
		    	 				<xsl:apply-templates select="./*/*/Term" mode="select"/>		    	 				
		    				</select>	    	 				    		
	    	 	</xsl:when>
    	 	<xsl:otherwise>
    	 		<xsl:call-template name="list"/>    
    	 	</xsl:otherwise>
    	 </xsl:choose>
    </div>	 
	
</xsl:template>	

<xsl:template name="header">
	<h2>MDRepository Statistics</h2>	
	<table>
		<tbody>
			<tr><td>context-path</td><td align="right"><xsl:value-of select="/Terms/Term/@path"/></td></tr>
			<tr><td>maxdepth</td><td align="right"><xsl:value-of select="/Terms/@depth"/></td></tr>
			<tr><td>count distinct Terms</td><td align="right"><xsl:value-of select="count(distinct-values(//Term/@path))"/></td></tr>
			<tr><td>count Terms</td><td align="right"><xsl:value-of select="format-number(sum(//Term/@count),'#.###','european')"/></td></tr>
			<tr><td>count txt</td><td align="right"><xsl:value-of select="format-number(sum(//Term/@count_text),'#.###','european')"/></td></tr>									
		</tbody>
	</table>
</xsl:template>		
	
<xsl:template name="table">
	<table>
		<caption>Terms Usage</caption>
		<thead><tr><th>name/path</th><th>count elems</th><th>count text</th><th>count distinct text</th></tr></thead>
		<tbody>		
			<xsl:apply-templates select="*" mode="table" />			
		</tbody>
	</table>

</xsl:template>

<xsl:template match="Term" mode="table">
				<tr><td><a href="?q={@path}" >
					<xsl:value-of select="translate(@path,'/','.')"/></a></td>
						<td align="right"><xsl:value-of select="@count"/></td>
						<td align="right"><xsl:value-of select="@count_text"/></td>						
						<td align="right"><xsl:value-of select="@count_distinct_text"/></td>						
				</tr>							
				<xsl:apply-templates select="*" mode="table" />			
</xsl:template>

<xsl:template name="list">
	<div id="terms">		
		<!--  format:<xsl:value-of select="$format" /> -->
		<xsl:variable name="translated_term" select="translate(replace(/*/Term[1]/@path,'//',''),'/','.')" />
		<!-- <input id="query_terms" value="{$translated_term}" /> -->		
		<ul class="treeview">
			<xsl:apply-templates select="/*/Term/Term" mode="list" />			
		</ul>	
	</div>
</xsl:template>

<xsl:template match="Term" mode="list" >
		<!--  <xsl:variable name="translated_path" select="translate(replace(@path,'//',''),'/','.')" /> -->
				<li><div class="cmds-elem-plus"><span class="detail-caller"><a href="{concat($detail_model_prefix,@context)}" >
					<xsl:value-of select="@name"/></a></span>
					<span class="note">|<xsl:value-of select="@count"/>/<xsl:value-of select="@count_text"/>/<xsl:value-of select="@count_distinct_text"/>|</span>					
					<span class="data comppath"><xsl:value-of select="@path" /></span>		 
					<span class="cmd cmd_filter"><xsl:text> </xsl:text></span>
					<span class="cmd cmd_detail" ><xsl:text> </xsl:text></span>
					<span class="cmd cmd_columns" ><xsl:text> </xsl:text></span>
						<div class="detail">
							<xsl:for-each select="@*" >
								<div class="cmds-elem-prop"><span class="label"><xsl:value-of select="name()" />: </span>
									<span class="value"><xsl:value-of select="." /></span></div>
							</xsl:for-each>
						</div>
					</div>
					<ul><xsl:apply-templates select="*" mode="list" /></ul>				
				</li>			
</xsl:template>


<xsl:template name="terms-tree" >
					<table id="modeltree" >
						<thead>
						<tr><th class="treecol">Name</th><th>Count Elems</th><th>Count Text</th><th>Count Distinct Text</th><th>Path</th><th>comp/datcat</th></tr>
						</thead>					
						<xsl:apply-templates select="*/Term" mode="detail">
							<xsl:sort order="ascending" select="@n" />							
						</xsl:apply-templates>
					</table>
</xsl:template>					

<xsl:template match="Term" mode="detail" >
<xsl:param name="parentid" select="'x-'" />

<xsl:variable name="lv" select="count(ancestor::Term)" />

	<xsl:variable name="xid" >
		<xsl:choose>
		<xsl:when test="$lv=0"><xsl:value-of select="concat($parentid,position())" /></xsl:when>
		<xsl:otherwise><xsl:value-of select="concat($parentid,'-', position())" /></xsl:otherwise>
		</xsl:choose> 
	</xsl:variable>
	
	<tr id="{$xid}" >
	  <xsl:if test="$lv!=0" >
	  	<xsl:attribute name="class" select="concat('child-of-',$parentid)" />
	  </xsl:if>
		<td class="treecol" ><xsl:value-of select="@name" /></td>		
		<td class="number"><xsl:value-of select="@count" /></td>
		<td class="number"><xsl:value-of select="@count_text" /></td>
		<td class="number"><xsl:value-of select="@count_distinct_text" /></td>
		<td><xsl:value-of select="@path" />,<xsl:value-of select="@context" /></td>			
		<td><xsl:value-of select="@corresponding_component" />,<xsl:value-of select="@datcat" /></td>
     </tr> 
		<xsl:if test="Term and ($lv&lt;$max_depth or $max_depth=0)">
			
				<xsl:choose>
					<xsl:when test="$sort='s'">				
						<xsl:apply-templates select="Term" mode="detail">
							<xsl:with-param name="parentid" select="$xid" />			
								<xsl:sort order="descending" select="@count_distinct_text" data-type="number" />
						</xsl:apply-templates>		
					</xsl:when>
					<xsl:when test="$sort='n'">				
					<xsl:apply-templates select="Term" mode="detail">
							<xsl:with-param name="parentid" select="$xid" />
								<xsl:sort order="ascending" select="@n" />
						</xsl:apply-templates>
					</xsl:when>
					<xsl:otherwise>
					<!--  testwise: show only non empty Terms, no good, because only leaf-elements have filled @count_distinct_text
						<xsl:apply-templates select="Term[@count_distinct_text &gt; 1]" mode="detail"> -->
						<xsl:apply-templates select="Term" mode="detail"> 
							<xsl:with-param name="parentid" select="$xid" />								
						</xsl:apply-templates>		
					</xsl:otherwise>
				</xsl:choose>					
					
		</xsl:if>
	
</xsl:template>

<xsl:template match="Term" mode="select">
	<xsl:variable name="lv" select="count(ancestor::Term)" />
	
	<option value="{@name}" ><xsl:value-of select="for $i in (2 to $lv) return ' '" /><xsl:value-of select="@name" /> |<xsl:value-of select="@count" />|</option>
		<xsl:apply-templates select="Term" mode="select" />			
</xsl:template>

<!-- 
<xsl:template name="list-datcats" >
					<table id="datcats" >
						<thead>
						<tr><th class="treecol">Name</th><th>Count Elems</th><th>Count Text</th><th>Count Distinct Text</th><th>Path</th><th>comp/datcat</th></tr>
						</thead>					
						<xsl:apply-templates select="*/Term" mode="detail">
							<xsl:sort order="ascending" select="@n" />							
						</xsl:apply-templates>
					</table>
</xsl:template>					
 -->
<xsl:template name="list-datcats">
	<xsl:param name="matrix" select="."></xsl:param>
	<table>
		<caption>DatCats |<xsl:value-of select="count(distinct-values($matrix//Term/@datcat))" />| <span class="note">* Click on numbers to see detail </span></caption>
				<thead><tr><th rowspan="2">id</th><th rowspan="2">name</th>
					<th colspan="3" >count </th><th rowspan="2">elems</th></tr>
					<tr><th>profile*</th><th >all*</th><th>elems</th> </tr>		</thead>
		<tbody>		
				<xsl:for-each-group select="$matrix//Term" group-by="@datcat">
					<xsl:sort select="lower-case(@datcat)" order="ascending"/>					
						<tr><td valign="top"><xsl:value-of select="my:shortURL(@datcat)"/></td>
						<td valign="top"><xsl:value-of select="my:rewriteURL(@datcat)"/></td>
						<td valign="top" align="right">
							<span class="detail-caller" ><xsl:value-of select="count(distinct-values(current-group()/@name))"/></span>
							<div class="detail" >
									<div class="box_heading"><xsl:value-of select="my:rewriteURL(@datcat)"/></div>
									<ul>
										<xsl:for-each select="distinct-values(current-group()/@name)" >
											<li><xsl:value-of select="." /></li>
										</xsl:for-each>
									</ul>
								</div>							
						</td>
						<td valign="top" align="right">
							<span class="term_detail_caller" ><xsl:value-of select="count(current-group())"/></span>
							<div class="term_detail" >
									<div class="box_heading"><xsl:value-of select="my:rewriteURL(@datcat)"/></div>
									<ul>
										<xsl:for-each-group select="current-group()" group-by="@name" >
											<li><xsl:value-of select="@name" />
													<ul>
														<xsl:for-each select="current-group()/@context" >
																<li><xsl:value-of select="." /></li>
														</xsl:for-each>
													</ul>
											</li>
										</xsl:for-each-group>
									</ul>
								</div>							
						</td>
						<td valign="top" align="right"><xsl:value-of select="count(distinct-values(current-group()/@elem))"/></td>						
							
						<td width="40%">						
								<xsl:for-each select="distinct-values(current-group()/@elem)">
									<xsl:sort select="." />
									<xsl:value-of select="."/>,
								</xsl:for-each>
						</td>												
						</tr>					
				</xsl:for-each-group>
		</tbody>
	</table>
	</xsl:template>





<xsl:template name="callback-header" >
	<style type="text/css">
		#modeltree { margin-left: 10px; border: 1px solid #9999aa; border-collapse: collapse;}
		.number { text-align: right; }
		td { border-bottom: 1px solid #9999aa; padding: 1px 4px;}
		.treecol {padding-left: 1.5em;}
		table thead {background: #ccccff; font-size:0.9em; }
		table thead tr th { border:1px solid #9999aa; font-weight:normal; text-align:left; padding: 1px 4px;}

	</style> 
	<script type="text/javascript" >
		$(function(){
			$("#modeltree").treeTable({initialState:"expanded"});
		});
	</script>
</xsl:template>



</xsl:stylesheet>