<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	
	
	
<!-- 	<xsl:param name="title" select="'Default Title'" />  -->
	<xsl:param name="format"  select="'htmltable'"/> <!-- table|list -->
	<xsl:param name="display_values_limit" select="10" />
	<xsl:param name="max_depth" select="0" />
	
	<xsl:param name="base_dir" select="'/MDService2'" />
	<xsl:param name="base_url" select="'http://localhost:8080/MDService2/'" />
	
	<xsl:param name="docs_baseuri" select="concat($base_dir, '/docs/htmlpage/welcome')" />
	
	<!-- momentary used in dcif2view.xsl to select appropriate language section 
	should be universal language-selector eventually -->
	<xsl:param name="lang" select="'en'" />
	<xsl:param name="default_lang" select="'en'" />
	
	
	<!-- <xsl:param name="model_matrix_uri" select="'http://localhost:8080/MDService2/model/matrix?maxdepth=8&amp;q='" /> -->
	<xsl:param name="model_matrix_uri" select="'http://localhost:8080/MDService2/model/matrix?q='" />
	<xsl:param name="datcats_terms_uri" select="'http://localhost:8080/MDService2/datcats/terms/?q='" />
	<xsl:param name="terms_setup_uri" select="'http://localhost:8080/MDService2/datcats/xml/?q='" />
	<xsl:param name="terms_flat_uri" select="'http://localhost:8080/MDService2/terms/flat/?q=all'" />
	
			
	<xsl:param name="repository_name" select="''" />
	<xsl:param name="q" select="''" />
	
	<!--  for resolving components by suffixing with @ComponentId -->
	<!-- <xsl:param name="components_uri" select="'http://catalog.clarin.eu/ds/ComponentRegistry/rest/registry/components/'" /> -->
	<!--  redirecting the resolution via MDService, to be able to make use of the cache
		the absolute-URL is not nice, however I wasn't able to tell XSL how to resolve a relative url 
	-->	
	<xsl:param name="cmdprofiles_uri" select="'http://localhost:8080/MDService2/compprofile/xml/'" />
	<xsl:param name="components_uri" select="'http://localhost:8080/MDService2/comp/xml/'" />		
	<xsl:param name="components_id_prefix" select="'clarin.eu:cr1:'" />
	<xsl:param name="components_viewer_uri" select="'http://catalog.clarin.eu/ds/ComponentRegistry/?item='" />
	
	<xsl:param name="autocolumns_limit" select="6" />
	<xsl:param name="resourceref_limit" select="20" />

<!--	<xsl:param name="recordset_prefix" select="concat($base_dir, '/record/htmldetail/')" />	-->
	<xsl:param name="default_prefix" select="concat($base_dir, '/', replace($format, '2','/'), '/')" />
	
	<xsl:param name="detail_comp_prefix"  select="'comp/htmldetail/'"/> 
	<xsl:param name="detail_profile_prefix"  select="'compprofile/htmldetail/'"/> 
	<xsl:param name="detail_complist_prefix"  select="if(contains(name(/*),'profile')) then $detail_profile_prefix else $detail_comp_prefix"/>
	
	<xsl:param name="detail_model_prefix"  select="'?q='"/>
	<!--  <xsl:param name="detail_uri_prefix"  select="'?q='"/> -->
				
	<!--  for rewriting links to DatCats (redirecting via MDService) -->			
	<xsl:param name="isocat_base_uri" select="'http://www.isocat.org/datcat/'" />	
	<xsl:param name="isocat_uri_match" select="'http://www.isocat.org/datcat/DC-'" />		
	<xsl:param name="isocat_uri_replace" select="'isocat/htmldiv/'" />
	
	
	<xsl:param name="cache_cols_" >id date duration repository collection lang query squery startItem maximumItems maxDepth</xsl:param>   
	<xsl:param name="cache_cols" select="tokenize($cache_cols_,'\s+')"  />
	
	<xsl:param name="name_element" select="('title', 'name', 'resourcename', 'md-title')"  />
	
	<xsl:param name="user" select="''"  />
		
	
	
</xsl:stylesheet>