<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="xml" />
<xsl:param name="server" />
<xsl:param name="port" />
<xsl:param name="basepath" />

<xsl:template  match="/" ><zs:explainResponse xmlns:zs="http://www.loc.gov/zing/srw/">
	<zs:version>1.2</zs:version>
	<zs:record>
	<zs:recordSchema>http://explain.z3950.org/dtd/2.0/</zs:recordSchema>
	<zs:recordPacking>xml</zs:recordPacking>
	<zs:recordData>
	<explain xmlns="http://explain.z3950.org/dtd/2.0/">
      <serverInfo>
	<host>localhost</host>
	<port>8080</port>
	<database>MDService2/sru</database>
      </serverInfo>
      <databaseInfo>
	<title>MDService</title>
	<description lang="en" primary="true">CLARIN MDService</description>
      </databaseInfo>
      
      <schemaInfo>
          <schema name="dc" identifier="info:srw/schema/1/dc-v1.1">
            <title>Simple Dublin Core</title>
          </schema>          

        </schemaInfo>
        <indexInfo>
          <set name="dc" identifier="info:srw/cql-context-set/1/dc-v1.1" />
          <index>
            <title lang="en">Title</title>
            <map>
              <name set="dc">title</name>
            </map>
          </index>
        </indexInfo>
        <configInfo>
          <default type="numberOfRecords">25</default>
          <setting type="maximumRecords">100</setting>
          <supports type="proximity" />
        </configInfo>
    </explain></zs:recordData></zs:record></zs:explainResponse>
</xsl:template>

	<xsl:template match="/other">
<sru:explainResponse xmlns:sru="http://www.loc.gov/zing/srw/">
 <sru:version>1.1</sru:version>
 <sru:record>
   <sru:recordPacking>XML</sru:recordPacking>
   <sru:recordSchema>http://explain.z3950.org/dtd/2.1/</sru:recordSchema>
   <sru:recordData>

   <zr:explain xmlns:zr="http://explain.z3950.org/dtd/2.1/">
     <zr:serverInfo protocol="SRU" version="1.2" transport="http"
                    method="GET">
        <zr:host><xsl:value-of select="$server" /></zr:host>
        <zr:port><xsl:value-of select="$port" /></zr:port>
        <zr:database><xsl:value-of select="$basepath" /></zr:database>
     </zr:serverInfo>
     <zr:databaseInfo>
       <title lang="en" primary="true">CLARIN MDService SRU</title>
     </zr:databaseInfo>
     <zr:indexInfo>
       <zr:set name="dc" identifier="info:srw/cql-context-set/1/dc-v1.1"/>
        <zr:index>
          <zr:map><zr:name set="dc">title</zr:name></zr:map>
        </zr:index>
     </zr:indexInfo>
     <zr:schemaInfo>
        <zr:schema name="dc" identifier="info:srw/schema/1/dc-v1.1">
          <zr:title>Simple Dublin Core</zr:title>
        </zr:schema>
     </zr:schemaInfo>
     <zr:configInfo>
         <zr:default type="numberOfRecords">1</zr:default>
         <zr:setting type="maximumRecords">50</zr:setting>
         <zr:supports type="proximity"/>
     </zr:configInfo>
    </zr:explain>

   </sru:recordData>
 </sru:record>
</sru:explainResponse>
	</xsl:template>
</xsl:stylesheet>