<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0"
   xmlns:exsl="http://exslt.org/common"
   extension-element-prefixes="exsl">

<!--
analyzes the structure of xml-input: 
	output: all xpaths
	strategy: 2 steps! : 
		1. flatten verbalize elements
		2. aggregate 
-->

<!-- <xsl:key name="names" match="NAME" use="concat('',@aliastype)"/> -->

<xsl:key name="elem_names" match="elem" use="."/>

<!--
<xsl:key name="divided_elems" match="*[@part]" use="concat(name(),':',@part)"/>
<xsl:key name="person_unique" match="NXElem[@boldtype='Person']" use="concat(names/NXElem[xtype='default']/token,occs/NXElem[1]/occLocation,events/NXElem[xtype='birth']/date)"/>
-->

<xsl:param name="dataset" select="/" />

<xsl:variable name="flatted" >
      <xsl:call-template name="flatten" />
   </xsl:variable>
	
<xsl:template name="xml-ay" >
   <xsl:param name="dataset" select="$dataset"></xsl:param>
		
    	<xsl:variable name="summarized">    	   
      	<xsl:call-template name="summarize" >
      	   <xsl:with-param name="flatted">
      	      <xsl:call-template name="flatten">
      	         <xsl:with-param name="dataset" select="$dataset"></xsl:with-param>
      	      </xsl:call-template>
      	   </xsl:with-param>    	   
      	</xsl:call-template>
    	</xsl:variable>
      <xsl:copy-of select="$summarized"></xsl:copy-of>
</xsl:template>

<xsl:template name="flatten">
   <xsl:param name="dataset" select="$dataset"></xsl:param>
   <xsl:variable name="flatted">
	<flatted>
	<xsl:for-each select="$dataset//*" >
	     <elem n="{name()}">
				<xsl:call-template name="path" />				
			</elem>		
	</xsl:for-each>
	</flatted></xsl:variable>   
   <xsl:copy-of select="$flatted"></xsl:copy-of>
</xsl:template>

<xsl:template name="summarize" >
   <xsl:param name="flatted" ></xsl:param>
   <xsl:message>count flatted <xsl:value-of select="count($flatted/flatted/elem)"></xsl:value-of></xsl:message>
<!-- match="flatted"
	 <xsl:for-each select="flatted/elem[generate-id() = generate-id(key('elem_names',.)[1])]" > -->
	<xsl:for-each-group select="$flatted/flatted/elem" group-by=".">	
		<Term name="{@n}" path="{.}" count="{count(current-group())}" />		
	</xsl:for-each-group>
</xsl:template>

<xsl:template name="path" >
	<xsl:for-each select="ancestor::*" ><xsl:value-of select="name()" />/</xsl:for-each><xsl:value-of select="name()" />
</xsl:template>


<!--
<xsl:template match="*[1]">
<xsl:param name="path" />
	<xsl:value-of select="name()" />
	<xsl:value-of select="count(../*[name()=name(current())])" />
	<xsl:text>&#xD;&#xA;</xsl:text>
		<xsl:apply-templates	/>
</xsl:template>
-->

</xsl:stylesheet>
